#include <stdlib.h>
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>

bool screengrabs = 1;

double min(double a, double b)
{
	return (a < b) ? a : b;
}

double max(double a, double b)
{
	return (a > b) ? a : b;
}

int pic = 0;
const float pi = 3.14159265358972;
float angle = 180.0;
float eyez = 0.0, eyex = 29.0;
float centerx = 0.0, centerz = 6.0;
int mainWin, mapWin;
int width, height;
int numofexhibits = 4;
int exhibit[5][2] = {{10, -5}, {7, 5}, {0, -5}, {-7, 5}, {-10, -5}};

/* Light Properties */
GLfloat light_ambient[] = {.2, .2, .2, 1}, light_ambient2[] = {.2, .2, .2, 1};
GLfloat light_diffuse[] = {.75, .75, .75, 1}, light_diffuse2[] = {.75, .75, .75, 1};
GLfloat light_specular[] = {1.0, 1.0, 1.0, 0.6}, light_specular2[] = {1, 1, 1, .6};
GLfloat light_position[] = {0, 9.5, 0.0, 0.2}, light_position2[] = {25.0, 9.0, 0, 0};
GLfloat map_light_position[] = {-1.0, 0.0, 0.0, 0.0};

char *number(int num)
{
	int numdigits = int(floor(log(num) / log(10)));
	char *str = new char[4];
	str[3] = 0;
	for (int i=2; i>=0; i--)
	{
		if (i > numdigits) str[2-i] = '0';
		else
		{
			int digit = int(num/pow(10,i));
			str[2-i] = (char)(48+digit);
			num -= int(digit*pow(10,i));
		}
	}
	return str;
}


int screenShot()
{
  // we will store the image data here
  unsigned char *pixels;
  // the thingy we use to write files
  FILE * shot;
  // we get the width/height of the screen into this array
  int screenStats[4];

  // get the width/height of the window
  glGetIntegerv(GL_VIEWPORT, screenStats);

  // generate an array large enough to hold the pixel data 
  // (width*height*bytesPerPixel)
  pixels = new unsigned char[screenStats[2]*screenStats[3]*3];
  // read in the pixel data, TGA's pixels are BGR aligned
  glReadPixels(0, 0, screenStats[2], screenStats[3], GL_BGR, 
                                   GL_UNSIGNED_BYTE, pixels);

  // open the file for writing. If unsucessful, return 1
		
  char *filename = new char[12];
  const char *temp = number(pic/2);
  cout << "temp: " << temp << endl;
  filename[0]='i';
  filename[1]='m';
  filename[2]='g';
  filename[3]='/';
  for(int x=0; x<3; x++)
    filename[x+4]=temp[x];
  filename[7]='.';
  filename[8]='t';
  filename[9]='g';
  filename[10]='a';
  filename[11]=0;

  cout << "filename: " << filename << endl;
	
  if((shot=fopen(filename, "wb"))==NULL) return 1;

  // this is the tga header it must be in the beginning of 
  // every (uncompressed) .tga
  unsigned char TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};
  // the header that is used to get the dimensions of the .tga
  // header[1]*256+header[0] - width
  // header[3]*256+header[2] - height
  // header[4] - bits per pixel
  // header[5] - ?
  unsigned char header[6]={((int)(screenStats[2]%256)),
                   ((int)(screenStats[2]/256)),
                   ((int)(screenStats[3]%256)),
		   ((int)(screenStats[3]/256)),24,0};

  // write out the TGA header
  fwrite(TGAheader, sizeof(unsigned char), 12, shot);
  // write out the header
  fwrite(header, sizeof(unsigned char), 6, shot);
  // write the pixels
  fwrite(pixels, sizeof(unsigned char), 
                 screenStats[2]*screenStats[3]*3, shot);

  // close the file
  fclose(shot);
  // free the memory
  delete [] pixels;

  // return success
  return 0;
}

void drawHalls(void)
{
  glPushMatrix();                   // wall - hallway #1 
    glColor3f(1.0, 0.843, 0.506);
    glTranslatef( 0, 5, 5);
    glScalef(40, 11, 1);  
    glutSolidCube(1.0);
  glPopMatrix();
      
  glPushMatrix();                   // wall - hallway #1
    glTranslatef( 0, 5, -5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(25, 5, 19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(-25, 5, 19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(0, 5, 30);
    glScalef(90, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glTranslatef(25, 5, 45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #2
    glTranslatef(25, 5, -45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(25, 5, -19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(-25, 5, -19.5);
    glScalef(40, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glRotatef(90.0, 0.0, 1.0, 0.0);
    glTranslatef(0, 5, -30);
    glScalef(90, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glTranslatef(-25, 5, 45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // wall - hallway #3
    glTranslatef(-25, 5, -45);
    glScalef(11, 11, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();					// door
    glColor3f(.9, .5, .18);
    glTranslatef(30, 3, 0);
    glScalef(1.12, 7, 3);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();					// door knob
    glColor3f(1, 1, 0);
    glTranslatef(29.3, 3.2, 1.2);
    glScalef(.2, .2, .2);
    glutSolidSphere(1, 15, 15);
  glPopMatrix();
}

static GLuint textureIDs[9];

GLuint readTexture(const char* filename)
{
	ifstream infile(filename);
	if(infile.fail()) exit(0);
	do 
	{
		infile.ignore(200, '\n');
	} 
	while(infile.peek() == '#');
	int width, height, depth;
	infile >> width >> height >> depth;
	GLubyte* texMap = new GLubyte[width * height * 3];
	int temp;
	for(int i = 0; i < height * width * 3; i++)
	{
		infile >> temp;
		//if(i == height - 1 && k % 3 == 0) temp = 255;
		texMap[i/* * (j * 3) + j * 3 + k*/] = char(temp);
	}
	infile.close();
	GLuint texID;
	glGenTextures(1, &texID);
	glBindTexture(GL_TEXTURE_2D, texID);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, width, height, GL_RGB, GL_UNSIGNED_BYTE, texMap);
	delete[] texMap; //otherwise it'll be in memory twice
	return texID;
}

void textureInit()
{
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	textureIDs[0] = readTexture("door1.ppm");//door1.ppm
	textureIDs[1] = readTexture("floor2.ppm");
	textureIDs[2] = readTexture("walls1.ppm");
	textureIDs[3] = readTexture("ceiling1.ppm");
	textureIDs[4] = readTexture("exhibitflappers.ppm");
	textureIDs[5] = readTexture("exhibitdepression.ppm");
	textureIDs[6] = readTexture("exhibithindenburg.ppm");
	textureIDs[7] = readTexture("exhibitmccarthy.ppm");
	textureIDs[8] = readTexture("exhibitapollo.ppm");
	glPixelStorei(GL_UNPACK_ALIGNMENT, GL_UNSIGNED_BYTE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

void drawExhibits(void)
{
	glColor3f(.8, .6, .3);
	
  glPushMatrix();                   // exhibit 0
    glTranslatef(0, 5.0, -4.9);
    glScalef(2, 2, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // exhibit 1
    glTranslatef(10, 5.0, -4.9);
    glScalef(2, 2, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // exhibit 2
    glTranslatef(-10, 5.0, -4.9);
    glScalef(2, 2, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // exhibit 3
    glTranslatef(7, 5.0, 4.9);
    glScalef(2, 2, 1);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // exhibit 4
    glTranslatef(-7, 5.0, 4.9);
    glScalef(2, 2, 1);
    glutSolidCube(1.0);
  glPopMatrix();
}

void drawFloors(void)
{
  glPushMatrix();                   // floor - hallway #1
    glColor3f(1.0, 1.0, 1.0);
    glScalef(40, 1, 10);    
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // floor - hallway #2
    glTranslatef(25, 0, 0);
    glScalef(10, 1, 90);    
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();                   // floor - hallway #3
    glTranslatef(-25, 0, 0);
    glScalef(10, 1, 90);    
    glutSolidCube(1.0);
  glPopMatrix();
}

void drawTexture(int texNum, float x1, float y1, float z1, float x2, float y2, float z2)
{
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);//or GL_BLEND, GL_REPLACE
	glBindTexture(GL_TEXTURE_2D, textureIDs[texNum]);
	if(x1 == x2)
	{
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3f(x1, y1, z1);
			glTexCoord2f(1.0, 0.0); glVertex3f(x1, y1, z2);
			glTexCoord2f(1.0, 1.0); glVertex3f(x1, y2, z2);
			glTexCoord2f(0.0, 1.0); glVertex3f(x1, y2, z1);
		glEnd();
	}
	else if(y1 == y2)
	{
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3f(x1, y1, z1);
			glTexCoord2f(1.0, 0.0); glVertex3f(x2, y1, z1);
			glTexCoord2f(1.0, 1.0); glVertex3f(x2, y1, z2);
			glTexCoord2f(0.0, 1.0); glVertex3f(x1, y1, z2);
		glEnd();
	}
	else if(z1 == z2)
	{
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3f(x1, y1, z1);
			glTexCoord2f(1.0, 0.0); glVertex3f(x2, y1, z1);
			glTexCoord2f(1.0, 1.0); glVertex3f(x2, y2, z1);
			glTexCoord2f(0.0, 1.0); glVertex3f(x1, y2, z1);
		glEnd();
	}
	glFlush();
	glDisable(GL_TEXTURE_2D);
}

void displayFont(char* str)
{
	int len = strlen(str);
	for(int i = 0; i < len; i++)
		glutStrokeCharacter(GLUT_STROKE_ROMAN, int(str[i]));
}

void drawExtras()
{
	for(int i = 0; i < 2; i++)		//door
		for(int j = 0; j < 2; j++)
			drawTexture(0, 29.43, 3.25 * i, -1.5 + 1.5 * j, 29.43, 3.25 + 3.25 * i, 1.5 * j);
			
	//floors
	for(int i = 0; i < 9; i++)
	{
		drawTexture(1, -30, .51, -45 + 10 * i, -27.5, .51, -35 + 10 * i);
		drawTexture(1, -25, .51, -45 + 10 * i, -27.5, .51, -35 + 10 * i);
		drawTexture(1, -25, .51, -45 + 10 * i, -22.5, .51, -35 + 10 * i);
		drawTexture(1, -20, .51, -45 + 10 * i, -22.5, .51, -35 + 10 * i);
		
		drawTexture(1, 20, .51, -45 + 10 * i, 22.5, .51, -35 + 10 * i);
		drawTexture(1, 25, .51, -45 + 10 * i, 22.5, .51, -35 + 10 * i);
		drawTexture(1, 25, .51, -45 + 10 * i, 27.5, .51, -35 + 10 * i);
		drawTexture(1, 30, .51, -45 + 10 * i, 27.5, .51, -35 + 10 * i);
	}
	for(int i = 0; i < 8; i++)
	{
		drawTexture(1, -17.5 + 10 * i, .51, -5, -20 + 10 * i, .51, 5);
		drawTexture(1, -17.5 + 10 * i, .51, -5, -15 + 10 * i, .51, 5);
		drawTexture(1, -12.5 + 10 * i, .51, -5, -15 + 10 * i, .51, 5);
		drawTexture(1, -12.5 + 10 * i, .51, -5, -10 + 10 * i, .51, 5);
	}
	
	//walls--height is from 0.5 to 10.5
	for(int i = 0; i < 8; i++)//middle hallway
	{
		drawTexture(2, -20 + 5 * i, 0.5, -4.49, -15 + 5 * i, 5.5, -4.49);
		drawTexture(2, -20 + 5 * i, 5.5, -4.49, -15 + 5 * i, 10.5, -4.49);
		drawTexture(2, -20 + 5 * i, 0.5, 4.49, -15 + 5 * i, 5.5, 4.49);
		drawTexture(2, -20 + 5 * i, 5.5, 4.49, -15 + 5 * i, 10.5, 4.49);
	}
	for(int i = 0; i < 18; i++)//end halls
	{
		drawTexture(2, -29.49, 0.5, -45 + 5 * i, -29.49, 5.5, -40 + 5 * i);
		drawTexture(2, -29.49, 5.5, -45 + 5 * i, -29.49, 10.5, -40 + 5 * i);
		drawTexture(2, 29.49, 0.5, -45 + 5 * i, 29.49, 5.5, -40 + 5 * i);
		drawTexture(2, 29.49, 5.5, -45 + 5 * i, 29.49, 10.5, -40 + 5 * i);
	}
	for(int i = 0; i < 8; i++)//end inside halls
	{
		drawTexture(2, -20.01, 0.5, -45 + 5 * i, -20.01, 5.5, -39.5 + 5 * i);
		drawTexture(2, -20.01, 5.5, -45 + 5 * i, -20.01, 10.5, -39.5 + 5 * i);
		drawTexture(2, -20.01, 0.5, 45 - 5 * i, -20.01, 5.5, 39.5 - 5 * i);
		drawTexture(2, -20.01, 5.5, 45 - 5 * i, -20.01, 10.5, 39.5 - 5 * i);
		drawTexture(2, 20.01, 0.5, -45 + 5 * i, 20.01, 5.5, -39.5 + 5 * i);
		drawTexture(2, 20.01, 5.5, -45 + 5 * i, 20.01, 10.5, -39.5 + 5 * i);
		drawTexture(2, 20.01, 0.5, 45 - 5 * i, 20.01, 5.5, 39.5 - 5 * i);
		drawTexture(2, 20.01, 5.5, 45 - 5 * i, 20.01, 10.5, 39.5 - 5 * i);
	}
	for(int i = 0; i < 2; i++)//end end halls
	{
		drawTexture(2, -30 + 5 * i, 0.5, -44.49, -25 + 5 * i, 5.5, -44.49);
		drawTexture(2, -30 + 5 * i, 5.5, -44.49, -25 + 5 * i, 10.5, -44.49);
		drawTexture(2, 30 - 5 * i, 0.5, -44.49, 25 - 5 * i, 5.5, -44.49);
		drawTexture(2, 30 - 5 * i, 5.5, -44.49, 25 - 5 * i, 10.5, -44.49);
		drawTexture(2, -30 + 5 * i, 0.5, 44.49, -25 + 5 * i, 5.5, 44.49);
		drawTexture(2, -30 + 5 * i, 5.5, 44.49, -25 + 5 * i, 10.5, 44.49);
		drawTexture(2, 30 - 5 * i, 0.5, 44.49, 25 - 5 * i, 5.5, 44.49);
		drawTexture(2, 30 - 5 * i, 5.5, 44.49, 25 - 5 * i, 10.5, 44.49);
	}
	
	for(int i = 0; i < 6; i++)//ceiling
		for(int j = 0; j < 30; j++)
		{
			drawTexture(3, -30 + 10 * i, 10.5, -45 + 3 * j, -20 + 10 * i, 10.5, -42 + 3 * j);
		}
			
	drawTexture(8, -11, 6, -4.39, -9, 4, -4.39);
	drawTexture(7, -8, 6, 4.39, -6, 4, 4.39);
	drawTexture(6, -1, 6, -4.39, 1, 4, -4.39);
	drawTexture(5, 6, 6, 4.39, 8, 4, 4.39);
	drawTexture(4, 9, 6, -4.39, 11, 4, -4.39);
	
	glColor3f(0, 0, 0);
	glPushMatrix();
		glTranslatef(8.5, 6.25, -4.48);
		glScalef(.002, .0025, 1);
		displayFont("Exhibit 1:  '20s Flappers");
	glPopMatrix();
	glPushMatrix();
		glTranslatef(9, 6.25, 4.48);
		glRotatef(180, 0, 1, 0);
		glScalef(.002, .0025, 1);
		displayFont("Exhibit 2:  The Great Depression");
	glPopMatrix();
	glPushMatrix();
		glTranslatef(-2.25, 6.25, -4.48);
		glScalef(.002, .0025, 1);
		displayFont("Exhibit 3:  The Hindenburg Disaster");
	glPopMatrix();
	glPushMatrix();
		glTranslatef(-5.5, 6.25, 4.48);
		glRotatef(180, 0, 1, 0);
		glScalef(.002, .0025, 1);
		displayFont("Exhibit 4:  McCarthyism");
	glPopMatrix();
	glPushMatrix();
		glTranslatef(-12, 6.25, -4.48);
		glScalef(.002, .0025, 1);
		displayFont("Exhibit 5:  \"One Small Step...\"");
	glPopMatrix();
	
	glColor3f(0, 0, 0);				//exit background (black)
	glPushMatrix();
		glTranslatef(30, 8.5, 0);
		glScalef(1.01, 3, 5);
		glutSolidCube(1.0);
	glPopMatrix();
	glColor3f(1.0, 0.0, 0.0);		//exit sign
	glPushMatrix();
		glTranslatef(29.4, 8.05, -1);
		glRotatef(270, 0, 1, 0);
		glScalef(.008, .01, 1);
		glutStrokeCharacter(GLUT_STROKE_ROMAN, int('E'));
		glutStrokeCharacter(GLUT_STROKE_ROMAN, int('X'));
		glutStrokeCharacter(GLUT_STROKE_ROMAN, int('I'));
		glutStrokeCharacter(GLUT_STROKE_ROMAN, int('T'));
	glPopMatrix();
}

void mapDisplay()
{
	glLoadIdentity();
    gluOrtho2D(-35.0, 35.0, -50.0, 50.0);
    glClear(GL_COLOR_BUFFER_BIT);
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_QUADS);
		//floors
		glVertex2f(-30.0, -45.0);
		glVertex2f(-30.0, 45.0);
		glVertex2f(-20.0, 45.0);
		glVertex2f(-20.0, -45.0);
		glVertex2f(-20.0, -5.0);
		glVertex2f(-20.0, 5.0);
		glVertex2f(20.0, 5.0);
		glVertex2f(20.0, -5.0);
		glVertex2f(20.0, 45.0);
		glVertex2f(20.0, -45.0);
		glVertex2f(30.0, -45.0);
		glVertex2f(30.0, 45.0);
		glColor3f(1.0, 0.0, 1.0);//door
		glVertex2f(30, -7);
		glVertex2f(30, 7);
		glVertex2f(33, 7);
		glVertex2f(33, -7);
		glColor3f(0.1, 0.8, 0.2);//exhibits
		glVertex2f(3, 7);
		glVertex2f(3, 5);
		glVertex2f(-3, 5);
		glVertex2f(-3, 7);
		glVertex2f(7, 5);
		glVertex2f(7, 7);
		glVertex2f(13, 7);
		glVertex2f(13, 5);
		glVertex2f(-7, 5);
		glVertex2f(-7, 7);
		glVertex2f(-13, 7);
		glVertex2f(-13, 5);
		glVertex2f(4, -5);
		glVertex2f(4, -7);
		glVertex2f(10, -7);
		glVertex2f(10, -5);
		glVertex2f(-4, -5);
		glVertex2f(-4, -7);
		glVertex2f(-10, -7);
		glVertex2f(-10, -5);
	glEnd();
	float angle2 = angle * pi / 180;
	glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_POLYGON);
		glVertex2f(eyex + 4 * cos(angle2), -eyez + -4 * sin(angle2));
		glVertex2f(eyex + 4 * cos(angle2 + 3 * pi / 4), -eyez + -4 * sin(angle2 + 3 * pi / 4));
		glVertex2f(eyex + 4 * cos(angle2 - 3 * pi / 4), -eyez + -4 * sin(angle2 - 3 * pi / 4));
	glEnd();
    glFlush();
    glutSwapBuffers();
    glutPostRedisplay();
}

void display(void)
{
    centerx = eyex + 5.0 * cos(angle * pi / 180.0);
    centerz = eyez + 5.0 * sin(angle * pi / 180.0);

    gluPerspective( 60.0, 1.0 , 0.1,  120.0);
    
    glMatrixMode(GL_MODELVIEW);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    gluLookAt(eyex, 5.0, eyez,  
              centerx, 5.0, centerz,  
              0.0, 1.0, 0.0);

    glClearColor(1.0, 1.0, 1.0, 0.0);

    glPushMatrix();

    /* Light */
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	
	glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient2);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse2);
    glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular2);
    glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
	
	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);

    /* Enable Various Components */
    glEnable(GL_COLOR_MATERIAL);  
    glEnable(GL_LIGHT0);
	//glEnable(GL_LIGHT1);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
	GLfloat shine[] = {0.2, 0.2, 0.2};
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, shine);
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);

    drawHalls();
    drawExhibits();
    drawFloors();
	drawExtras();

    glPopMatrix();
    glFlush();
    glutSwapBuffers();
    glutPostRedisplay();
}

void myReshape(int w, int h) 
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();   
    gluPerspective( 40.0, (GLfloat) h / (GLfloat) w , 0.1,  120.0);
    glMatrixMode(GL_MODELVIEW);
}

bool inBounds(float x, float z)
{
	if((x > -29 && x < -21) || (x > 21 && x < 29)) return z < 44.5 && z > -44.5;
	else if(x >= -21 && x <= 21) return z < 4.2 && z > -4.2;
	else return false;
}

void keyboard(int key, int x, int y)
{
	float tempx, tempz;
  if(key == GLUT_KEY_LEFT) angle -= 2.0;
  else if(key == GLUT_KEY_RIGHT) angle += 2.0;
  else if(key == GLUT_KEY_UP) 
  {
    tempx = eyex + 0.2 * cos(angle * pi / 180.0);
    tempz = eyez + 0.2 * sin(angle * pi / 180.0);
	if(inBounds(tempx, tempz))
	{
		eyex = tempx;
		eyez = tempz;
	}
  }
  else if(key == GLUT_KEY_DOWN) 
  {
    tempx = eyex - 0.2 * cos(angle * pi / 180.0);
    tempz = eyez - 0.2 * sin(angle * pi / 180.0);
	if(inBounds(tempx, tempz))
	{
		eyex = tempx;
		eyez = tempz;
	}
  }
  glutPostRedisplay();

  if(pic < 200 && screengrabs)
  {
	if(pic%2==0) screenShot();
	pic++;
  }

}


void mouse(int button, int state, int x, int y)
{
	char* exhibitCall = new char[100];
  if (state == GLUT_DOWN)
  {
    for(int i = 0; i <= numofexhibits; i++)
    {
      	if((exhibit[i][0] - centerx) * (exhibit[i][0] - centerx) 
				+ (exhibit[i][1] - centerz) * (exhibit[i][1] - centerz) < 3)
		{
	  		cout << "Opening exhibit #" << i + 1 << endl;
			sprintf(exhibitCall, "mozilla http://www.tjhsst.edu/~lpham/supercomp/imagine/exhibit%i.htm", i);
			cout << exhibitCall << endl;
			system(exhibitCall);
			cout << "Exhibit #" << i + 1<< " closed\n";
		}
    }
  }
}

void fogInit()
{
	glEnable(GL_FOG);
	GLfloat fogcol[] = {.4, .4, .4, 1};
	glFogi(GL_FOG_MODE, GL_EXP2);
	glFogfv(GL_FOG_COLOR, fogcol);
	glFogf(GL_FOG_DENSITY, 0.02);
	glFogf(GL_FOG_START, .1);
	glFogf(GL_FOG_END, 125);
}

int main(int argc, char **argv)
{
   if(screengrabs)
   {
     width = 256;
     height = 256;
   }
   else
   {
	 width = 512;
	 height = 512;
   }
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
   glutInitWindowPosition(50, 50);
   glutInitWindowSize(width, height);
   mainWin = glutCreateWindow("VirtualMuseum");
	textureInit();
	fogInit();
   glutMouseFunc(mouse);
   glutSpecialFunc(keyboard);
   glutReshapeFunc(myReshape);
   glutDisplayFunc(display);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
   if(!screengrabs)
   {
 	 mapWin = glutCreateSubWindow(mainWin, 5, 5, 80, 80);
     glutDisplayFunc(mapDisplay);
   }
   glutMainLoop();
   return 0;
}
